# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.AppVersion do
  @moduledoc """
  This represents a single version of the app.

  ## Attributes

  *   `production` (*type:* `boolean()`, *default:* `nil`) - If the value is True, it indicates that this version is a production track.
  *   `trackIds` (*type:* `list(String.t)`, *default:* `nil`) - Track identifiers that the app version is published in. This does not include the production track (see production instead).
  *   `versionCode` (*type:* `integer()`, *default:* `nil`) - Unique increasing identifier for the app version.
  *   `versionString` (*type:* `String.t`, *default:* `nil`) - The string used in the Play store by the app developer to identify the version. The string is not necessarily unique or localized (for example, the string could be "1.4").
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :production => boolean() | nil,
          :trackIds => list(String.t()) | nil,
          :versionCode => integer() | nil,
          :versionString => String.t() | nil
        }

  field(:production)
  field(:trackIds, type: :list)
  field(:versionCode)
  field(:versionString)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.AppVersion do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.AppVersion.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.AppVersion do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
