# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.CertAuthorityRemovedEvent do
  @moduledoc """
  A root certificate was removed from the system's trusted credential storage. This is available device-wide on fully managed devices and within the work profile on organization-owned devices with a work profile.

  ## Attributes

  *   `certificate` (*type:* `String.t`, *default:* `nil`) - Subject of the certificate.
  *   `success` (*type:* `boolean()`, *default:* `nil`) - Whether the removal succeeded.
  *   `userId` (*type:* `integer()`, *default:* `nil`) - The user in which the certificate removal event occurred. Only available for devices running Android 11 and above.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :certificate => String.t() | nil,
          :success => boolean() | nil,
          :userId => integer() | nil
        }

  field(:certificate)
  field(:success)
  field(:userId)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.CertAuthorityRemovedEvent do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.CertAuthorityRemovedEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.CertAuthorityRemovedEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
