# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.CertValidationFailureEvent do
  @moduledoc """
  An X.509v3 certificate failed to validate, currently this validation is performed on the Wi-FI access point and failure may be due to a mismatch upon server certificate validation. However it may in the future include other validation events of an X.509v3 certificate.

  ## Attributes

  *   `failureReason` (*type:* `String.t`, *default:* `nil`) - The reason why certification validation failed.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :failureReason => String.t() | nil
        }

  field(:failureReason)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.CertValidationFailureEvent do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.CertValidationFailureEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.CertValidationFailureEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
