# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.ClearAppsDataParams do
  @moduledoc """
  Parameters associated with the CLEAR_APP_DATA command to clear the data of specified apps from the device.

  ## Attributes

  *   `packageNames` (*type:* `list(String.t)`, *default:* `nil`) - The package names of the apps whose data will be cleared when the command is executed.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :packageNames => list(String.t()) | nil
        }

  field(:packageNames, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.ClearAppsDataParams do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.ClearAppsDataParams.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.ClearAppsDataParams do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
