# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.ContactInfo do
  @moduledoc """
  Contact details for managed Google Play enterprises.

  ## Attributes

  *   `contactEmail` (*type:* `String.t`, *default:* `nil`) - Email address for a point of contact, which will be used to send important announcements related to managed Google Play.
  *   `dataProtectionOfficerEmail` (*type:* `String.t`, *default:* `nil`) - The email of the data protection officer. The email is validated but not verified.
  *   `dataProtectionOfficerName` (*type:* `String.t`, *default:* `nil`) - The name of the data protection officer.
  *   `dataProtectionOfficerPhone` (*type:* `String.t`, *default:* `nil`) - The phone number of the data protection officer The phone number is validated but not verified.
  *   `euRepresentativeEmail` (*type:* `String.t`, *default:* `nil`) - The email of the EU representative. The email is validated but not verified.
  *   `euRepresentativeName` (*type:* `String.t`, *default:* `nil`) - The name of the EU representative.
  *   `euRepresentativePhone` (*type:* `String.t`, *default:* `nil`) - The phone number of the EU representative. The phone number is validated but not verified.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :contactEmail => String.t() | nil,
          :dataProtectionOfficerEmail => String.t() | nil,
          :dataProtectionOfficerName => String.t() | nil,
          :dataProtectionOfficerPhone => String.t() | nil,
          :euRepresentativeEmail => String.t() | nil,
          :euRepresentativeName => String.t() | nil,
          :euRepresentativePhone => String.t() | nil
        }

  field(:contactEmail)
  field(:dataProtectionOfficerEmail)
  field(:dataProtectionOfficerName)
  field(:dataProtectionOfficerPhone)
  field(:euRepresentativeEmail)
  field(:euRepresentativeName)
  field(:euRepresentativePhone)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.ContactInfo do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.ContactInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.ContactInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
