# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.Display do
  @moduledoc """
  Device display information.

  ## Attributes

  *   `density` (*type:* `integer()`, *default:* `nil`) - Display density expressed as dots-per-inch.
  *   `displayId` (*type:* `integer()`, *default:* `nil`) - Unique display id.
  *   `height` (*type:* `integer()`, *default:* `nil`) - Display height in pixels.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of the display.
  *   `refreshRate` (*type:* `integer()`, *default:* `nil`) - Refresh rate of the display in frames per second.
  *   `state` (*type:* `String.t`, *default:* `nil`) - State of the display.
  *   `width` (*type:* `integer()`, *default:* `nil`) - Display width in pixels.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :density => integer() | nil,
          :displayId => integer() | nil,
          :height => integer() | nil,
          :name => String.t() | nil,
          :refreshRate => integer() | nil,
          :state => String.t() | nil,
          :width => integer() | nil
        }

  field(:density)
  field(:displayId)
  field(:height)
  field(:name)
  field(:refreshRate)
  field(:state)
  field(:width)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.Display do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.Display.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.Display do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
