# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.DnsEvent do
  @moduledoc """
  A DNS lookup event was initiated through the standard network stack.

  ## Attributes

  *   `hostname` (*type:* `String.t`, *default:* `nil`) - The hostname that was looked up.
  *   `ipAddresses` (*type:* `list(String.t)`, *default:* `nil`) - The (possibly truncated) list of the IP addresses returned for DNS lookup (max 10 IPv4 or IPv6 addresses).
  *   `packageName` (*type:* `String.t`, *default:* `nil`) - The package name of the UID that performed the DNS lookup.
  *   `totalIpAddressesReturned` (*type:* `String.t`, *default:* `nil`) - The number of IP addresses returned from the DNS lookup event. May be higher than the amount of ip_addresses if there were too many addresses to log.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :hostname => String.t() | nil,
          :ipAddresses => list(String.t()) | nil,
          :packageName => String.t() | nil,
          :totalIpAddressesReturned => String.t() | nil
        }

  field(:hostname)
  field(:ipAddresses, type: :list)
  field(:packageName)
  field(:totalIpAddressesReturned)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.DnsEvent do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.DnsEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.DnsEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
