# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.FreezePeriod do
  @moduledoc """
  A system freeze period. When a device’s clock is within the freeze period, all incoming system updates (including security patches) are blocked and won’t be installed.When the device is outside any set freeze periods, the normal policy behavior (automatic, windowed, or postponed) applies.Leap years are ignored in freeze period calculations, in particular: If Feb. 29th is set as the start or end date of a freeze period, the freeze period will start or end on Feb. 28th instead. When a device’s system clock reads Feb. 29th, it’s treated as Feb. 28th. When calculating the number of days in a freeze period or the time between two freeze periods, Feb. 29th is ignored and not counted as a day.Note: For Freeze Periods to take effect, SystemUpdateType cannot be specified as SYSTEM_UPDATE_TYPE_UNSPECIFIED, because freeze periods require a defined policy to be specified.

  ## Attributes

  *   `endDate` (*type:* `GoogleApi.AndroidManagement.V1.Model.Date.t`, *default:* `nil`) - The end date (inclusive) of the freeze period. Must be no later than 90 days from the start date. If the end date is earlier than the start date, the freeze period is considered wrapping year-end. Note: year must not be set. For example, {"month": 1,"date": 30}.
  *   `startDate` (*type:* `GoogleApi.AndroidManagement.V1.Model.Date.t`, *default:* `nil`) - The start date (inclusive) of the freeze period. Note: year must not be set. For example, {"month": 1,"date": 30}.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :endDate => GoogleApi.AndroidManagement.V1.Model.Date.t() | nil,
          :startDate => GoogleApi.AndroidManagement.V1.Model.Date.t() | nil
        }

  field(:endDate, as: GoogleApi.AndroidManagement.V1.Model.Date)
  field(:startDate, as: GoogleApi.AndroidManagement.V1.Model.Date)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.FreezePeriod do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.FreezePeriod.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.FreezePeriod do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
