# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.KeyguardDismissAuthAttemptEvent do
  @moduledoc """
  An attempt was made to unlock the device.

  ## Attributes

  *   `strongAuthMethodUsed` (*type:* `boolean()`, *default:* `nil`) - Whether a strong form of authentication (password, PIN, or pattern) was used to unlock device.
  *   `success` (*type:* `boolean()`, *default:* `nil`) - Whether the unlock attempt was successful.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :strongAuthMethodUsed => boolean() | nil,
          :success => boolean() | nil
        }

  field(:strongAuthMethodUsed)
  field(:success)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.KeyguardDismissAuthAttemptEvent do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.KeyguardDismissAuthAttemptEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.KeyguardDismissAuthAttemptEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
