# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.ListEnrollmentTokensResponse do
  @moduledoc """
  Response to a request to list enrollment tokens for a given enterprise.

  ## Attributes

  *   `enrollmentTokens` (*type:* `list(GoogleApi.AndroidManagement.V1.Model.EnrollmentToken.t)`, *default:* `nil`) - The list of enrollment tokens.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - If there are more results, a token to retrieve next page of results.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :enrollmentTokens =>
            list(GoogleApi.AndroidManagement.V1.Model.EnrollmentToken.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:enrollmentTokens, as: GoogleApi.AndroidManagement.V1.Model.EnrollmentToken, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.ListEnrollmentTokensResponse do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.ListEnrollmentTokensResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.ListEnrollmentTokensResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
