# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.ManagedProperty do
  @moduledoc """
  Managed property.

  ## Attributes

  *   `defaultValue` (*type:* `any()`, *default:* `nil`) - The default value of the property. BUNDLE_ARRAY properties don't have a default value.
  *   `description` (*type:* `String.t`, *default:* `nil`) - A longer description of the property, providing more detail of what it affects. Localized.
  *   `entries` (*type:* `list(GoogleApi.AndroidManagement.V1.Model.ManagedPropertyEntry.t)`, *default:* `nil`) - For CHOICE or MULTISELECT properties, the list of possible entries.
  *   `key` (*type:* `String.t`, *default:* `nil`) - The unique key that the app uses to identify the property, e.g. "com.google.android.gm.fieldname".
  *   `nestedProperties` (*type:* `list(GoogleApi.AndroidManagement.V1.Model.ManagedProperty.t)`, *default:* `nil`) - For BUNDLE_ARRAY properties, the list of nested properties. A BUNDLE_ARRAY property is at most two levels deep.
  *   `title` (*type:* `String.t`, *default:* `nil`) - The name of the property. Localized.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of the property.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :defaultValue => any() | nil,
          :description => String.t() | nil,
          :entries => list(GoogleApi.AndroidManagement.V1.Model.ManagedPropertyEntry.t()) | nil,
          :key => String.t() | nil,
          :nestedProperties =>
            list(GoogleApi.AndroidManagement.V1.Model.ManagedProperty.t()) | nil,
          :title => String.t() | nil,
          :type => String.t() | nil
        }

  field(:defaultValue)
  field(:description)
  field(:entries, as: GoogleApi.AndroidManagement.V1.Model.ManagedPropertyEntry, type: :list)
  field(:key)
  field(:nestedProperties, as: GoogleApi.AndroidManagement.V1.Model.ManagedProperty, type: :list)
  field(:title)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.ManagedProperty do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.ManagedProperty.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.ManagedProperty do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
