# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.PersonalApplicationPolicy do
  @moduledoc """
  Policies for apps in the personal profile of a company-owned device with a work profile.

  ## Attributes

  *   `installType` (*type:* `String.t`, *default:* `nil`) - The type of installation to perform.
  *   `packageName` (*type:* `String.t`, *default:* `nil`) - The package name of the application.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :installType => String.t() | nil,
          :packageName => String.t() | nil
        }

  field(:installType)
  field(:packageName)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.PersonalApplicationPolicy do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.PersonalApplicationPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.PersonalApplicationPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
