# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.ProvisioningInfo do
  @moduledoc """
  Information about a device that is available during setup.

  ## Attributes

  *   `apiLevel` (*type:* `integer()`, *default:* `nil`) - The API level of the Android platform version running on the device.
  *   `brand` (*type:* `String.t`, *default:* `nil`) - The brand of the device. For example, Google.
  *   `enterprise` (*type:* `String.t`, *default:* `nil`) - The name of the enterprise in the form enterprises/{enterprise}.
  *   `managementMode` (*type:* `String.t`, *default:* `nil`) - The management mode of the device or profile.
  *   `model` (*type:* `String.t`, *default:* `nil`) - The model of the device. For example, Asus Nexus 7.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of this resource in the form provisioningInfo/{provisioning_info}.
  *   `ownership` (*type:* `String.t`, *default:* `nil`) - Ownership of the managed device.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :apiLevel => integer() | nil,
          :brand => String.t() | nil,
          :enterprise => String.t() | nil,
          :managementMode => String.t() | nil,
          :model => String.t() | nil,
          :name => String.t() | nil,
          :ownership => String.t() | nil
        }

  field(:apiLevel)
  field(:brand)
  field(:enterprise)
  field(:managementMode)
  field(:model)
  field(:name)
  field(:ownership)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.ProvisioningInfo do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.ProvisioningInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.ProvisioningInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
