# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.RemoteLockEvent do
  @moduledoc """
  The device or profile has been remotely locked via the LOCK command.

  ## Attributes

  *   `adminPackageName` (*type:* `String.t`, *default:* `nil`) - Package name of the admin app requesting the change.
  *   `adminUserId` (*type:* `integer()`, *default:* `nil`) - User ID of the admin app from the which the change was requested.
  *   `targetUserId` (*type:* `integer()`, *default:* `nil`) - User ID in which the change was requested in.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :adminPackageName => String.t() | nil,
          :adminUserId => integer() | nil,
          :targetUserId => integer() | nil
        }

  field(:adminPackageName)
  field(:adminUserId)
  field(:targetUserId)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.RemoteLockEvent do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.RemoteLockEvent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.RemoteLockEvent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
