# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.SetupAction do
  @moduledoc """
  An action executed during setup.

  ## Attributes

  *   `description` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - Description of this action.
  *   `launchApp` (*type:* `GoogleApi.AndroidManagement.V1.Model.LaunchAppAction.t`, *default:* `nil`) - An action to launch an app. The app will be launched with an intent containing an extra with key com.google.android.apps.work.clouddpc.EXTRA_LAUNCHED_AS_SETUP_ACTION set to the boolean value true to indicate that this is a setup action flow. If SetupAction references an app, the corresponding installType in the application policy must be set as REQUIRED_FOR_SETUP or said setup will fail.
  *   `title` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - Title of this action.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :description => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil,
          :launchApp => GoogleApi.AndroidManagement.V1.Model.LaunchAppAction.t() | nil,
          :title => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil
        }

  field(:description, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
  field(:launchApp, as: GoogleApi.AndroidManagement.V1.Model.LaunchAppAction)
  field(:title, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.SetupAction do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.SetupAction.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.SetupAction do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
