# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.SpecificNonComplianceContext do
  @moduledoc """
  Additional context for SpecificNonComplianceReason.

  ## Attributes

  *   `oncWifiContext` (*type:* `GoogleApi.AndroidManagement.V1.Model.OncWifiContext.t`, *default:* `nil`) - Additional context for non-compliance related to Wi-Fi configuration. See ONC_WIFI_INVALID_VALUE and ONC_WIFI_API_LEVEL
  *   `passwordPoliciesContext` (*type:* `GoogleApi.AndroidManagement.V1.Model.PasswordPoliciesContext.t`, *default:* `nil`) - Additional context for non-compliance related to password policies. See PASSWORD_POLICIES_PASSWORD_EXPIRED and PASSWORD_POLICIES_PASSWORD_NOT_SUFFICIENT.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :oncWifiContext => GoogleApi.AndroidManagement.V1.Model.OncWifiContext.t() | nil,
          :passwordPoliciesContext =>
            GoogleApi.AndroidManagement.V1.Model.PasswordPoliciesContext.t() | nil
        }

  field(:oncWifiContext, as: GoogleApi.AndroidManagement.V1.Model.OncWifiContext)

  field(:passwordPoliciesContext, as: GoogleApi.AndroidManagement.V1.Model.PasswordPoliciesContext)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.SpecificNonComplianceContext do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.SpecificNonComplianceContext.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.SpecificNonComplianceContext do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
