# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.StartLostModeParams do
  @moduledoc """
  Parameters associated with the START_LOST_MODE command to put the device into lost mode. At least one of the parameters, not including the organization name, must be provided in order for the device to be put into lost mode.

  ## Attributes

  *   `lostEmailAddress` (*type:* `String.t`, *default:* `nil`) - The email address displayed to the user when the device is in lost mode.
  *   `lostMessage` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - The message displayed to the user when the device is in lost mode.
  *   `lostOrganization` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - The organization name displayed to the user when the device is in lost mode.
  *   `lostPhoneNumber` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - The phone number that will be called when the device is in lost mode and the call owner button is tapped.
  *   `lostStreetAddress` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - The street address displayed to the user when the device is in lost mode.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :lostEmailAddress => String.t() | nil,
          :lostMessage => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil,
          :lostOrganization => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil,
          :lostPhoneNumber => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil,
          :lostStreetAddress => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil
        }

  field(:lostEmailAddress)
  field(:lostMessage, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
  field(:lostOrganization, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
  field(:lostPhoneNumber, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
  field(:lostStreetAddress, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.StartLostModeParams do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.StartLostModeParams.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.StartLostModeParams do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
