# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.TermsAndConditions do
  @moduledoc """
  A terms and conditions page to be accepted during provisioning.

  ## Attributes

  *   `content` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - A well-formatted HTML string. It will be parsed on the client with android.text.Html#fromHtml.
  *   `header` (*type:* `GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t`, *default:* `nil`) - A short header which appears above the HTML content.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :content => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil,
          :header => GoogleApi.AndroidManagement.V1.Model.UserFacingMessage.t() | nil
        }

  field(:content, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
  field(:header, as: GoogleApi.AndroidManagement.V1.Model.UserFacingMessage)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.TermsAndConditions do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.TermsAndConditions.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.TermsAndConditions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
