# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AndroidManagement.V1.Model.UsageLog do
  @moduledoc """
  Controls types of device activity logs collected from the device and reported via Pub/Sub notification (https://developers.google.com/android/management/notifications).

  ## Attributes

  *   `enabledLogTypes` (*type:* `list(String.t)`, *default:* `nil`) - Specifies which log types are enabled. Note that users will receive on-device messaging when usage logging is enabled.
  *   `uploadOnCellularAllowed` (*type:* `list(String.t)`, *default:* `nil`) - Specifies which of the enabled log types can be uploaded over mobile data. By default logs are queued for upload when the device connects to WiFi.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :enabledLogTypes => list(String.t()) | nil,
          :uploadOnCellularAllowed => list(String.t()) | nil
        }

  field(:enabledLogTypes, type: :list)
  field(:uploadOnCellularAllowed, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.AndroidManagement.V1.Model.UsageLog do
  def decode(value, options) do
    GoogleApi.AndroidManagement.V1.Model.UsageLog.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AndroidManagement.V1.Model.UsageLog do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
